USRP Hardware Driver and USRP Manual: uhd::rfnoc::blockdef Class Reference

| USRP Hardware Driver and USRP Manual Version: 4.9.0.makepkg-0-g9ec1f582 UHD and USRP Manual |

Loading...
Searching...
No Matches
uhd::rfnoc::blockdef Class Referenceabstract

`#include <uhd/rfnoc/blockdef.hpp>`

Inheritance diagram for uhd::rfnoc::blockdef:

## Classes
class | port_t
| Describes port options for a block definition. More...
class | arg_t
| Describes arguments in a block definition. More...

## Public Types
typedef std::shared_ptr< blockdef > | sptr
typedef std::vector< port_t > | ports_t
typedef std::vector< arg_t > | args_t
typedef uhd::dict< std::string, size_t > | registers_t

## Public Member Functions
virtual bool | is_block () const =0
| Returns true if this represents a NoC block.
virtual bool | is_component () const =0
| Returns true if this represents a component.
virtual std::string | get_key () const =0
| Returns block key (i.e. what is used for the registry).
virtual std::string | get_name () const =0
| For blocks, returns the block name. For components, returns it's canonical name.
virtual uint64_t | noc_id () const =0
| Return the one NoC that is valid for this block.
virtual ports_t | get_input_ports ()=0
virtual ports_t | get_output_ports ()=0
virtual std::vector< size_t > | get_all_port_numbers ()=0
| Returns the full list of port numbers used.
virtual args_t | get_args ()=0
| Returns the args for this block. Checks if args are valid.
virtual registers_t | get_settings_registers ()=0
| Returns a list of settings registers by name.
virtual registers_t | get_readback_registers ()=0
| Returns a list of readback (user) registers by name.

## Static Public Member Functions
static sptr | make_from_noc_id (uint64_t noc_id)

## Detailed Description

Reads and stores block definitions for blocks and components.

## Member Typedef Documentation

## ◆ args_t

typedef std::vector<arg_t> uhd::rfnoc::blockdef::args_t

## ◆ ports_t

typedef std::vector<port_t> uhd::rfnoc::blockdef::ports_t

## ◆ registers_t

typedef uhd::dict<std::string, size_t> uhd::rfnoc::blockdef::registers_t

## ◆ sptr

typedef std::shared_ptr<blockdef> uhd::rfnoc::blockdef::sptr

## Member Function Documentation

## ◆ get_all_port_numbers()

virtual std::vector< size_t > uhd::rfnoc::blockdef::get_all_port_numbers | ( |  | ) |
| pure virtual

Returns the full list of port numbers used.

## ◆ get_args()

virtual args_t uhd::rfnoc::blockdef::get_args | ( |  | ) |
| pure virtual

Returns the args for this block. Checks if args are valid.

## ◆ get_input_ports()

virtual ports_t uhd::rfnoc::blockdef::get_input_ports | ( |  | ) |
| pure virtual

## ◆ get_key()

virtual std::string uhd::rfnoc::blockdef::get_key | ( |  | ) | const
| pure virtual

Returns block key (i.e. what is used for the registry).

## ◆ get_name()

virtual std::string uhd::rfnoc::blockdef::get_name | ( |  | ) | const
| pure virtual

For blocks, returns the block name. For components, returns it's canonical name.

## ◆ get_output_ports()

virtual ports_t uhd::rfnoc::blockdef::get_output_ports | ( |  | ) |
| pure virtual

## ◆ get_readback_registers()

virtual registers_t uhd::rfnoc::blockdef::get_readback_registers | ( |  | ) |
| pure virtual

Returns a list of readback (user) registers by name.

## ◆ get_settings_registers()

virtual registers_t uhd::rfnoc::blockdef::get_settings_registers | ( |  | ) |
| pure virtual

Returns a list of settings registers by name.

## ◆ is_block()

virtual bool uhd::rfnoc::blockdef::is_block | ( |  | ) | const
| pure virtual

Returns true if this represents a NoC block.

## ◆ is_component()

virtual bool uhd::rfnoc::blockdef::is_component | ( |  | ) | const
| pure virtual

Returns true if this represents a component.

## ◆ make_from_noc_id()

sptr uhd::rfnoc::blockdef::make_from_noc_id | ( | uint64_t | noc_id | ) |
| static

Create a block definition object for a NoC block given a NoC ID. This cannot be used for components.

Note: If nothing is found, returns an empty sptr. Does not throw.

## ◆ noc_id()

virtual uint64_t uhd::rfnoc::blockdef::noc_id | ( |  | ) | const
| pure virtual

Return the one NoC that is valid for this block.

The documentation for this class was generated from the following file:

- blockdef.hpp